//Importing all the packages from d3 java script library
import {
  select,
  json,
  csv,
  geoPath,
  geoAlbersUsa,
  geoMercator,
  scaleOrdinal,
  schemeCategory10,
} from 'd3';
import { feature, mesh } from 'topojson';
//using the select function
const svg = select('svg');

const projection = geoMercator()
  .translate([-1780, 1050])
  .scale([1600]);
const pathGenerator = geoPath().projection(projection);

const colorScale = scaleOrdinal(schemeCategory10);
//this file contains india map which is used for visualizing
json(
  'https://gist.githubusercontent.com/17761A04F1/843ddd1cb39c43a26690c9699146e2a2/raw/da9a86f99489e1db28f1c7c82027447ddef76a51/india.json'
).then((data) => {
  const countryShapes = feature(
    data,
    data.objects.IND_adm1
  );
countryShapes.features.shift()
 //countryShapes.features.forEach((d) => console.log(d.properties)  );
 //select all function helps in selecting all elements
  svg
    .selectAll('path')
    .data(countryShapes.features)
    .enter()
    .append('path')
    .attr('class', 'states')
    .attr('fill', (d) => colorScale(d.properties.NAME_1))
    .attr('d', (d) => pathGenerator(d))
    .append('title')
    .text((d) => d.properties.NAME_1);

svg
  .selectAll('text')
  .data(countryShapes.features)
  .enter()
  .append('text')
  .text((d) => d.properties.NAME_1)
  .attr('x', d=>  pathGenerator.centroid(d)[0]   )
  .attr('y',d=>pathGenerator.centroid(d)[1])
    .attr("text-anchor", "middle")
   .attr("font-size", "15px");
});